
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/datatypes.h>
#include <datatypes/pictureclass.h>
#include <string.h>


struct BitMap *copy_bitmap (struct BitMap *oldbm);

BOOL save_pic (char *filename,struct BitMap *bitmap,ULONG *palette)

{
BOOL rc = FALSE;
struct BitMap *newbm;
long d;
long ncols;
Object *o;
struct BitMapHeader *bmhd;
UBYTE *cmap;
ULONG *cregs;
long i;
BPTR fhand;

newbm = copy_bitmap (bitmap);

d = GetBitMapAttr (newbm,BMA_DEPTH);
ncols = d <= 8 ? 1 << d : 0;

if (o = NewDTObject (NULL,
		DTA_SourceType,DTST_RAM,
		DTA_GroupID,GID_PICTURE,
		PDTA_BitMap,newbm,
		PDTA_ModeID,0,
		PDTA_NumColors,ncols,
		TAG_END))
	{

	GetDTAttrs (o,PDTA_BitMapHeader,&bmhd,TAG_END);

	bmhd->bmh_Width  = GetBitMapAttr(newbm,BMA_WIDTH);
	bmhd->bmh_Height = GetBitMapAttr(newbm,BMA_HEIGHT);
	bmhd->bmh_Depth  = d;

	if (ncols)
		{
		GetDTAttrs (o,PDTA_ColorRegisters,&cmap,PDTA_CRegs,&cregs,TAG_END);
		for (i = 3*ncols-1; i >= 0; i--)
			{
			cregs[i] = palette[i];
			cmap[i] = palette[i] >> 24;
			}
		}

	if (fhand = Open (filename,MODE_NEWFILE))
		{
		i = DoDTMethod (o,NULL,NULL,DTM_WRITE,NULL,fhand,DTWM_IFF,TAG_END);
		Close (fhand);
		if (i)
			rc = TRUE;
		else
			DeleteFile (filename);
		}

	DisposeDTObject (o);
	}

return (rc);
}
